package uy.edu.fing.tse.central.business.startup;

import uy.edu.fing.tse.central.business.BusinessLocal;
import uy.edu.fing.tse.central.business.security.SecurityLocal;
import uy.edu.fing.tse.dto.*;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.EJB;
import javax.ejb.Singleton;
import javax.ejb.Startup;
import java.util.Date;

@Singleton
@Startup
public class Config {

    @EJB
    private BusinessLocal negocio;
    @EJB
    private SecurityLocal users;

    @PostConstruct
    public void start() {
        initRole();
        initUsers();
        initEstados();
        initScore();
        initFacts();
    }

    @PreDestroy
    public void stop() {
    }

    private void initRole() {
        Role e = new Role();
        e.setName("Admin");
        negocio.altaRol(e);

        e = new Role();
        e.setName("Submitter");
        negocio.altaRol(e);

        e = new Role();
        e.setName("Checker");
        negocio.altaRol(e);
    }

    private void initUsers() {
        UserBO u = new UserBO();
        u.setPassword("admin");
        u.setMail("admin");
        Role e = new Role();
        e.setName("Admin");
        u.setRole(e);
        users.register(u);


        u = new UserBO();
        u.setPassword("checker");
        u.setMail("checker");
        e = new Role();
        e.setName("Checker");
        u.setRole(e);
        users.register(u);


        u = new UserBO();
        u.setPassword("submitter");
        u.setMail("submitter");
        e = new Role();
        e.setName("Submitter");
        u.setRole(e);
        users.register(u);
    }

    private void initEstados() {
        //Nuevo, aComprobar, enProceso, Verificado, Publicado, Cancelado
        State e = new State();
        e.setValue("Nuevo");
        negocio.altaEstado(e);

        e = new State();
        e.setValue("A Comprobar");
        negocio.altaEstado(e);

        e = new State();
        e.setValue("En Proceso");
        negocio.altaEstado(e);

        e = new State();
        e.setValue("Verificado");
        negocio.altaEstado(e);

        e = new State();
        e.setValue("Publicado");
        negocio.altaEstado(e);

        e = new State();
        e.setValue("Cancelado");
        negocio.altaEstado(e);
    }

    private void initScore() {
        //vergonzosa, verdad a media, verdad, falsa
        Score e = new Score();
        e.setValue("vergonzosa");
        negocio.altaCalificacion(e);

        e = new Score();
        e.setValue("Verdad a medias");
        negocio.altaCalificacion(e);

        e = new Score();
        e.setValue("Verdad");
        negocio.altaCalificacion(e);

        e = new Score();
        e.setValue("Falsa");
        negocio.altaCalificacion(e);
    }

    private void initFacts() {
        String[] titulos = new String[10];
        String[] descripciones = new String[10];
        String[] estados = new String[10];

        titulos[0] = "Debutó la Unidad Previsional con éxito";
        titulos[1] = "Sin claras señales de cambios en el billete verde";
        titulos[2] = "Conaprole e Isusa colocaron US$ 17: en el mercado";
        titulos[3] = "¿Quiere ser de la nobleza? Compre un título en Escocia";
        titulos[4] = "¿Qué hacer con el dinero en momentos de \"nubarrones\"?";
        titulos[5] = "Cavani alcanzó al \"Cebolla\"";
        titulos[6] = "Petrobras emitió y captó US$ 2.000 millones";
        titulos[7] = "Bonos brasileños en manos de argentinos no pagarán impuestos";
        titulos[8] = "Noticia 9";
        titulos[9] = "esta es la ultima noticia";

        descripciones[0] = "Ayer, por primera vez, se emitió deuda en la recientemente creada Unidad Previsional (UP) que tiene cotización diaria y ajusta según la evolución del Índice Medio de Salarios Nominales.";
        descripciones[1] = "En Brasil la divisa estadounidense subió un 2,49% en la semana, y en Argentina un 6,81%.";
        descripciones[2] = "Dos emisiones donde la demanda superó el monto ofertado.";
        descripciones[3] = "¿Le apetece unirse a la nobleza escocesa? Esta región del norte de Reino Unido ha visto desarrollarse toda una industria que permite que la gente ordinaria haga justamente eso, algunos con más justificación legal que otros.";
        descripciones[4] = "Presidente y director de la Bolsa de Valores hicieron análisis y sugerencias.";
        descripciones[5] = "PSG se consagró y el \"Matador\" es uno de los uruguayos con más títulos";
        descripciones[6] = "La petrolera brasileña Petrobras informó ayer que captó US$ 2.000 millones con el lanzamiento el jueves en el exterior de títulos con vencimiento en 2029 por los que pagará un interés anual del 5,750%.";
        descripciones[7] = "Bonos brasileños en manos de argentinos no pagarán impuestos";
        descripciones[8] = "descripcion noticia 9";
        descripciones[9] = "descripcion noticia 10";

        estados[0] = "Verificado";
        estados[1] = "Verificado";
        estados[2] = "Nuevo";
        estados[3] = "Nuevo";
        estados[4] = "Nuevo";
        estados[5] = "Verificado";
        estados[6] = "Verificado";
        estados[7] = "Nuevo";
        estados[8] = "Verificado";
        estados[9] = "Nuevo";

        for (int i = 0; i < 10; i++) {
            State actualState = new State();
            actualState.setValue(estados[i]);
            final var fact = new Fact();
            fact.setTitle(titulos[i]);
            fact.setDescription(descripciones[i]);
            fact.setActualState(actualState);
            StateHistory sh = new StateHistory();
            sh.setState(actualState);
            sh.setDate(new Date());
            UserBO u = new UserBO();
            u.setMail("admin");
            sh.setUser(u);
            fact.addHistory(sh);
            negocio.altaHecho(fact);
        }
    }
}
